#ifndef CONTOUR_H
#define CONTOUR_H
#include <variable.h>
#include <algorithm>
#include <object.h>
#include <iostream>

double tol=2; //tollerance
int contournr=0;
int sequencenr=0;

void swap_object(int i);
void colorize_grey(int i);
void colorize_blue(int i);
void map_endpoints();
void map_single_objects();
void map_open_contours();
void map_closed_contours();
int find_next_and_swap(int source, int type, int first_object); //type 0=open, type 1=closed

void contour(){

    message="contour";
    contournr=0;
    sequencenr=0;

    //reset
    for(int i=0; i<objects.size(); i++){
        objects.at(i).select=0;
        objects.at(i).start_match=-1; //start with open end
        objects.at(i).end_match=-1; //start with open end
        objects.at(i).red = 1;
        objects.at(i).green = 1;
        objects.at(i).blue = 1;
        objects.at(i).alpha = 1;
        objects.at(i).contournr = 0;
        objects.at(i).sequencenr = 0;
    }

    map_endpoints();
    map_single_objects();
    map_open_contours();
    map_closed_contours();

    //print output
    for(int i=0; i<objects.size(); i++){

        if(objects.at(i).select==1){
            std::cout<<"object nr:"<<i<<std::endl;
            std::cout<<"contournr:"<<objects.at(i).contournr<<std::endl;
            std::cout<<"object sequencenr following path:"<<objects.at(i).sequencenr<<std::endl;
            std::cout<<"xstart:"<<objects.at(i).start.x<<std::endl;
            std::cout<<"ystart:"<<objects.at(i).start.y<<std::endl;

            std::cout<<"xend:"<<objects.at(i).end.x<<std::endl;
            std::cout<<"yend:"<<objects.at(i).end.y<<std::endl;
            std::cout<<" "<<std::endl;
        }
    }
}

void map_endpoints(){

    for(int i=0; i<objects.size(); i++){
        for(int j=0; j<objects.size(); j++){
            if(i!=j){ //don't look at the same object in this function

                //find end-end match
                if((objects.at(i).end.x<objects.at(j).end.x+tol) && (objects.at(i).end.x>objects.at(j).end.x-tol) && (objects.at(i).end.y<objects.at(j).end.y+tol) && (objects.at(i).end.y>objects.at(j).end.y-tol)){
                    objects.at(i).end_match=j;
                }

                //find end-start match
                if((objects.at(i).end.x<objects.at(j).start.x+tol) && (objects.at(i).end.x>objects.at(j).start.x-tol) && (objects.at(i).end.y<objects.at(j).start.y+tol) && (objects.at(i).end.y>objects.at(j).start.y-tol)){
                    objects.at(i).end_match=j;
                }

                //find start-start match
                if((objects.at(i).start.x<objects.at(j).start.x+tol) && (objects.at(i).start.x>objects.at(j).start.x-tol) && (objects.at(i).start.y<objects.at(j).start.y+tol) && (objects.at(i).start.y>objects.at(j).start.y-tol)){
                    objects.at(i).start_match=j;
                }

                //find start-end match
                if((objects.at(i).start.x<objects.at(j).end.x+tol) && (objects.at(i).start.x>objects.at(j).end.x-tol) && (objects.at(i).start.y<objects.at(j).end.y+tol) && (objects.at(i).start.y>objects.at(j).end.y-tol)){
                    objects.at(i).start_match=j;
                }
            }
        }
    }

    //look for single closed objects, like splines, arc's etc.
    for(int i=0; i<objects.size(); i++){

        if(objects.at(i).type=="spline" || objects.at(i).type=="arc" || objects.at(i).type=="linestrip" ){
            if((objects.at(i).start.x<objects.at(i).end.x+tol) && (objects.at(i).start.x>objects.at(i).end.x-tol) && (objects.at(i).start.y<objects.at(i).end.y+tol) && (objects.at(i).start.y>objects.at(i).end.y-tol)){
                objects.at(i).start_match=i;
                objects.at(i).end_match=i;
                objects.at(i).contourtype=2;
            }
        }
    }


    //map circle's to single closed contour objects
    for(int i=0; i<objects.size(); i++){
        if(objects.at(i).type=="circle"){
            objects.at(i).start_match=-1;
            objects.at(i).end_match=-1;
            objects.at(i).contourtype=2;
        }
    }

    //print output
    for(int i=0; i<objects.size(); i++){
        std::cout<<"object nr:"<<i<<std::endl;
        std::cout<<"start match:"<<objects.at(i).start_match<<std::endl;
        std::cout<<"end match:"<<objects.at(i).end_match<<std::endl;
        std::cout<<" "<<std::endl;
    }
}

void map_single_objects(){
    for(int i=0; i<objects.size(); i++){
        if(objects.at(i).start_match==-1 && objects.at(i).end_match==-1){
            objects.at(i).select=1;
            objects.at(i).contournr=contournr;
            contournr++;
            colorize_grey(i);
        }
    }
}

void map_open_contours(){

    //find free left open object
    for(int i=0; i<objects.size(); i++){

        //swap right side open ends to to left side open ends.
        if(objects.at(i).end_match==-1 && objects.at(i).select==0){
            //if(objects.at(i).type=="line"){
            swap_object(i);
            //}
        }

        if(objects.at(i).start_match==-1 && objects.at(i).select==0){

            objects.at(i).contournr=contournr;

            int source=i;
repeat:
            int next = find_next_and_swap(source,0,0);

            if(objects.at(next).end_match!=-1){
                source=next;
                goto repeat;
            }
        }
    }
}

void map_closed_contours(){

    //find free left open object
    for(int i=0; i<objects.size(); i++){

        if(objects.at(i).contourtype!=2 && objects.at(i).start_match!=-1 && objects.at(i).end_match!=-1 && objects.at(i).select==0){

            objects.at(i).contournr=contournr;

            int source=i;
repeat:
            int next = find_next_and_swap(source,1,i);

            if(objects.at(next).end_match!=i){
                source=next;
                goto repeat;
            }
        }

        if(objects.at(i).contourtype==2){ //possible single closed contours, like spline's and arc's etc, to be expanded
            objects.at(i).select=1;
            colorize_blue(i);
            contournr++;
        }

    }
}

int find_next_and_swap(int source, int type, int first_object){

    int target=0;
    for(int j=0; j<objects.size(); j++){
        //find end-end match
        if(source!=j && (objects.at(source).end.x<objects.at(j).end.x+tol) && (objects.at(source).end.x>objects.at(j).end.x-tol) && (objects.at(source).end.y<objects.at(j).end.y+tol) && (objects.at(source).end.y>objects.at(j).end.y-tol)){
            //if(objects.at(j).type=="line"){
            swap_object(j);
            //}
        }
        //find end-start match
        if(source!=j && (objects.at(source).end.x<objects.at(j).start.x+tol) && (objects.at(source).end.x>objects.at(j).start.x-tol) && (objects.at(source).end.y<objects.at(j).start.y+tol) && (objects.at(source).end.y>objects.at(j).start.y-tol)){
            target=j;
            objects.at(source).select=1;
            objects.at(target).select=1;
            objects.at(target).contournr=contournr;
            sequencenr++;
            objects.at(target).sequencenr=sequencenr;
            if(type==0){
                colorize_grey(source);
                colorize_grey(target);
            }
            if(type==1){
                colorize_blue(source);
                colorize_blue(target);
            }

            if(type==0 && objects.at(target).end_match==-1){ //type open contour
                sequencenr=0; //reset contour sequencenr
                contournr++;
            }

            if(type==1 && objects.at(target).end_match==first_object){ //type closed contour
                sequencenr=0; //reset contour sequencenr
                contournr++;
            }

            break;
        }
    }
    return target;
}

void swap_object(int i){
    double start_x = objects.at(i).start.x;
    double start_y = objects.at(i).start.y;
    double start_z = objects.at(i).start.z;
    objects.at(i).start.x=objects.at(i).end.x;
    objects.at(i).start.y=objects.at(i).end.y;
    objects.at(i).start.z=objects.at(i).end.z;
    objects.at(i).end.x=start_x;
    objects.at(i).end.y=start_y;
    objects.at(i).end.z=start_z;

    std::reverse(objects.at(i).control.begin(), objects.at(i).control.end());

    int te=objects.at(i).end_match;
    int ts=objects.at(i).start_match;
    objects.at(i).start_match=te;
    objects.at(i).end_match=ts;
}

void colorize_grey(int i){
    objects.at(i).red = 106;
    objects.at(i).green = 106;
    objects.at(i).blue = 106;
    objects.at(i).alpha = 255;
}

void colorize_blue(int i){
    objects.at(i).red = 0;
    objects.at(i).green = 0;
    objects.at(i).blue = 1;
    objects.at(i).alpha = 1;
}

#endif // CONTOUR_H














