#include <variable.h>
#include <iostream>
#include <fstream>
#include <string.h>
#include <object.h>

void rgba_spline(int color);

//http://help.autodesk.com/view/ACD/2016/ENU/?guid=GUID-E1F884F8-AA90-4864-A215-3182D47A9C74

void read_spline(std::string filename)
{
    bool trigger=0;
    unsigned int layer_line=0;
    unsigned int color_line=0;
    unsigned int x_line=0;
    unsigned int y_line=0;
    unsigned int z_line=0;
    unsigned int x_control_line=0;
    unsigned int y_control_line=0;
    unsigned int z_control_line=0;
    unsigned int x_start_tangent_line=0;
    unsigned int y_start_tangent_line=0;
    unsigned int z_start_tangent_line=0;
    unsigned int x_end_tangent_line=0;
    unsigned int y_end_tangent_line=0;
    unsigned int z_end_tangent_line=0;
    std::string layer;
    unsigned int color = 0;
    double x=0;
    double y=0;
    double z=0;

    bool spline_startpoint=1;

    unsigned int linenumber=0;
    char count[200]; //line buffer
    FILE *file=fopen(filename.c_str(), "r"); //convert std::string to std::char

    while(file && fgets(count, sizeof(count), file)){
        linenumber++;

        if(strstr(count,"SPLINE")&& !strstr(count,"$SPLINETYPE")&& !strstr(count,"$SPLINESEGS")){
            //std::cout<<"spline found at:"<<linenumber<< std::endl;
            trigger=1;
            object.type="spline";
        }

        if(trigger && strstr(count,"  8")){
            //cout<<"8 found at:"<<linenumber<< endl;
            layer_line=linenumber+1;
        }
        if(trigger && linenumber==layer_line){
            //cout<<"layer:"<<count<< endl;
            //spline.layer=count;
            object.layer=count;
        }

        if(trigger && strstr(count," 62")){
            //cout<<"62 found at:"<<linenumber<< endl;
            color_line=linenumber+1;
        }
        if(trigger && linenumber==color_line){
            //cout<<"color:"<<count<< endl;
            rgba_spline(std::stoi(count));
        }

//        //10,20,30 are Control points, cad test
//        if(trigger && strstr(count," 10")){
//            //std::cout<<"xcontrol found"<<std::endl;
//            x_control_line=linenumber+1;
//        }
//        if(trigger && linenumber==x_control_line){
//            std::cout<<"x control:"<<count<<std::endl;
//            spline.x=std::stod(count);
//        }

//        if(trigger && strstr(count," 20")){
//            //std::cout<<"ycontrol found"<<std::endl;
//            y_control_line=linenumber+1;
//        }
//        if(trigger && linenumber==y_control_line){
//            std::cout<<"y control:"<<count<<std::endl;
//            spline.y=std::stod(count);
//        }

//        if(trigger && strstr(count," 30")){
//            //std::cout<<"zcontrol found"<<std::endl;
//            z_control_line=linenumber+1;
//        }
//        if(trigger && linenumber==z_control_line){
//            std::cout<<"z control:"<<count<<std::endl;
//            spline.z=std::stod(count);
//        }

//        //12,22,32 is start tangent, cad test
//        if(trigger && strstr(count," 12")){
//            x_start_tangent_line=linenumber+1;
//        }
//        if(trigger && linenumber==x_start_tangent_line){
//            std::cout<<"x_start_tangent:"<<count<<std::endl;
//        }

//        if(trigger && strstr(count," 22")){
//            y_start_tangent_line=linenumber+1;
//        }
//        if(trigger && linenumber==y_start_tangent_line){
//            std::cout<<"y_start_tangent:"<<count<<std::endl;
//        }

//        if(trigger && strstr(count," 32")){
//            z_start_tangent_line=linenumber+1;
//        }
//        if(trigger && linenumber==z_start_tangent_line){
//            std::cout<<"z_start_tangent:"<<count<<std::endl;
//        }

        //11,21,31 are Fit points, is used by Inkscape for drawing the complete spline
        if(trigger && strstr(count," 11")){
            //cout<<"10 found at:"<<linenumber<< endl;
            x_line=linenumber+1;
        }
        if(trigger && linenumber==x_line){
            //std::cout<<"x fit:"<<count<<std::endl;
            if(spline_startpoint){
                object.start.x=std::stod(count);
            } else {
                object.control.push_back({0,0,0}); //create controlpoint
                object.control.back().x=std::stod(count); //fill controlpoint
            }

        }

        if(trigger && strstr(count," 21")){
            //std::cout<<"20 found at:"<<linenumber<<std::endl;
            y_line=linenumber+1;
        }
        if(trigger && linenumber==y_line){
            //std::cout<<"y fit:"<<count<<std::endl;
            if(spline_startpoint){
                object.start.y=std::stod(count);
            } else {
                object.control.back().y=std::stod(count);
            }
        }

        if(trigger && strstr(count," 31")){
            //std::cout<<"30 found at:"<<linenumber<<std::endl;
            z_line=linenumber+1;
        }
        if(trigger && linenumber==z_line){
            //std::cout<<"z fit:"<<count<<std::endl;
            if(spline_startpoint){
                object.start.z=std::stod(count);
            } else {
                object.control.back().z=std::stod(count);
            }

            spline_startpoint=0; //go on with controlpoints

        }

        if(trigger && strstr(count,"  0")){
            //std::cout<<"0 found at:"<<linenumber<<std::endl;

            //endpoint coordinates from last controlpoint
            object.end.x=object.control.back().x;
            object.end.y=object.control.back().y;
            object.end.z=object.control.back().z;

            //erase last controlpoint
            object.control.pop_back();

            //when no colorcode " 62" is found..
            if(object.red==0 && object.green==0 && object.blue==0 && object.alpha==0){
                object.red = 255;
                object.green = 255;
                object.blue = 255;
                object.alpha = 255;
            }

            objects.push_back(object); //save program data

            //reset object value's
            object.type="";
            object.layer="";
            object.red=0;
            object.green=0;
            object.blue=0;
            object.alpha=0;
            object.start.x=0;
            object.start.y=0;
            object.start.z=0;
            object.control.clear();
            object.end.x=0;
            object.end.y=0;
            object.end.z=0;
            object.center.x=0;
            object.center.y=0;
            object.center.z=0;
            object.radius=0;
            object.deg_angle_start=0;
            object.deg_angle_end=0;

            trigger=0;
            spline_startpoint=1;
        }
    }
}

void rgba_spline(int color)
{
    if(color == 1){ //red
        object.red = 255;
        object.green = 0;
        object.blue = 0;
        object.alpha = 255;
    } else if(color == 2){ //yellow
        object.red = 255;
        object.green = 255;
        object.blue = 0;
        object.alpha = 255;
    } else if(color == 3){ //green
        object.red = 0;
        object.green = 255;
        object.blue = 0;
        object.alpha = 255;
    } else if(color == 4){ //cyan
        object.red = 255;
        object.green = 0;
        object.blue = 255;
        object.alpha = 255;
    } else if(color == 5){ //blue
        object.red = 49;
        object.green = 112;
        object.blue = 206;
        object.alpha = 255;
    } else if(color == 6){ //magenta
        object.red = 0;
        object.green = 255;
        object.blue = 255;
        object.alpha = 255;
    } else if(color == 7){ //white
        object.red = 255;
        object.green = 255;
        object.blue = 255;
        object.alpha = 255;
    } else if(color == 8){ //grey
        object.red = 106;
        object.green = 106;
        object.blue = 106;
        object.alpha = 255;
    } else if(color == 9){ //orange/brown
        object.red = 255;
        object.green = 170;
        object.blue = 0;
        object.alpha = 255;
    } else {
        object.red = 255; //when no standard colorcode is found we use white
        object.green = 255;
        object.blue = 255;
        object.alpha = 255;
    }
}













