#include <mainwindow.h>
#include "ui_mainwindow.h"
#include <opengl.h>
#include <variable.h>
#include <object.h>
#include <functions.h>
#include <iostream>
#include <dxf/read_line.h>
#include <dxf/read_spline.h>
#include <dxf/read_circle.h>
#include <dxf/read_arc.h>
#include <dxf/read_ellipse.h>
#include <dxf/read_dimension.h>
#include <dxf/read_text.h>
#include <cam/contour.h>

#define MyQLineEdit() << QLineEdit() << fixed << qSetRealNumberPrecision(3)
//int nr=0;

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    timerId = startTimer(100);
}

MainWindow::~MainWindow()
{
    killTimer(timerId);
    delete ui;
}

void MainWindow::timerEvent(QTimerEvent *)
{
    ui->lineEdit_mx->setText(QString::number(mx,'f',6));
    ui->lineEdit_my->setText(QString::number(my,'f',6));
    ui->lineEdit_message->setText(QString::fromStdString(message));
}

void MainWindow::keyPressEvent(QKeyEvent *event)
{
    int_key = event->key();
    std::cout<<"key:"<<int_key<<std::endl;
}

void MainWindow::keyReleaseEvent(QKeyEvent *event)
{

}

void MainWindow::on_toolButton_open_pressed()
{
    //    Dialog_file dialog;
    //    dialog.setModal(true);
    //    dialog.exec();

#define DXF_FILES "AC1027 dxf files (*.dxf)"
#define GRO_FILES "gro files (*.gro)"

    QFileDialog *dialog = new QFileDialog;
    dialog->resize(500,250);
    QString selectedFilter;

    QString filename_open = QFileDialog::getOpenFileName(
                dialog,
                "Open",
                QDir::currentPath(),
                DXF_FILES ";;" GRO_FILES,
                &selectedFilter,
                QFileDialog::DontUseNativeDialog); //this solves a dxf multiload problem

    if(selectedFilter == GRO_FILES){
        //(read_gro(filename_open));
    }
    if(selectedFilter == DXF_FILES){
        read_line(std::string(filename_open.toStdString()));
        read_spline(std::string(filename_open.toStdString()));
        read_circle(std::string(filename_open.toStdString()));
        read_arc(std::string(filename_open.toStdString()));
        read_ellipse(std::string(filename_open.toStdString()));
        read_dimension(std::string(filename_open.toStdString()));
        read_text(std::string(filename_open.toStdString()));
    }
}

void MainWindow::on_toolButton_line_pressed()
{
    mode="line";
}

void MainWindow::on_toolButton_linestrip_pressed()
{
    mode="linestrip";
}

void MainWindow::on_toolButton_rectangular_pressed()
{
    mode="rectangular";
}

void MainWindow::on_toolButton_circle_pressed()
{
    mode="circle";
}

void MainWindow::on_toolButton_ellipse_pressed()
{
    mode="ellipse";
}

void MainWindow::on_toolButton_arc_pressed()
{
    mode="arc";
}

void MainWindow::on_toolButton_spline_pressed()
{
    mode="spline";
}

void MainWindow::on_toolButton_bezier_pressed()
{
    mode="bezier";
}

void MainWindow::on_toolButton_polygon_pressed()
{
    mode="polygon";
}

void MainWindow::on_toolButton_contour_pressed()
{
    mode="";
    contour();

}

void MainWindow::on_toolButton_debug_pressed()
{
    std::cout<<"objects:"<<objects.size()<<std::endl;
}






